OpenMesh

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Groups Pages
List of all members
OpenMesh::PolyMesh_ArrayKernelT< Traits > Class Template Reference
Predefined Mesh Types

Polygonal mesh based on the ArrayKernel. More...

`#include <OpenMesh/Mesh/Types/PolyMesh_ArrayKernelT.hh>`

Inheritance diagram for OpenMesh::PolyMesh_ArrayKernelT< Traits >:
[legend]
Collaboration diagram for OpenMesh::PolyMesh_ArrayKernelT< Traits >:
[legend]

## Additional Inherited Members
Public Types inherited from OpenMesh::PolyMeshT< Kernel >
typedef PolyMeshT< Kernel > | This
| Self type. Used to specify iterators/circulators.
typedef Kernel::VertexHandle | VertexHandle
| Handle for referencing the corresponding item.
typedef Kernel::HalfedgeHandle | HalfedgeHandle
typedef Kernel::EdgeHandle | EdgeHandle
typedef Kernel::FaceHandle | FaceHandle
typedef Kernel::VertexIter | VertexIter
typedef Kernel::HalfedgeIter | HalfedgeIter
typedef Kernel::EdgeIter | EdgeIter
typedef Kernel::FaceIter | FaceIter
typedef Kernel::ConstVertexIter | ConstVertexIter
typedef Kernel::ConstHalfedgeIter | ConstHalfedgeIter
typedef Kernel::ConstEdgeIter | ConstEdgeIter
typedef Kernel::ConstFaceIter | ConstFaceIter
typedef Kernel::Scalar | Scalar
| Scalar type.
typedef Kernel::Point | Point
| Coordinate type.
typedef Kernel::Normal | Normal
| Normal type.
typedef Kernel::Color | Color
| Color type.
typedef Kernel::TexCoord1D | TexCoord1D
| TexCoord1D type.
typedef Kernel::TexCoord2D | TexCoord2D
| TexCoord2D type.
typedef Kernel::TexCoord3D | TexCoord3D
| TexCoord3D type.
typedef Kernel::Vertex | Vertex
| Vertex type.
typedef Kernel::Halfedge | Halfedge
| Halfedge type.
typedef Kernel::Edge | Edge
| Edge type.
typedef Kernel::Face | Face
| Face type.
typedef Kernel::VertexVertexIter | VertexVertexIter
| Circulator.
typedef Kernel::VertexOHalfedgeIter | VertexOHalfedgeIter
| Circulator.
typedef Kernel::VertexIHalfedgeIter | VertexIHalfedgeIter
| Circulator.
typedef Kernel::VertexEdgeIter | VertexEdgeIter
| Circulator.
typedef Kernel::VertexFaceIter | VertexFaceIter
| Circulator.
typedef Kernel::FaceVertexIter | FaceVertexIter
| Circulator.
typedef Kernel::FaceHalfedgeIter | FaceHalfedgeIter
| Circulator.
typedef Kernel::FaceEdgeIter | FaceEdgeIter
| Circulator.
typedef Kernel::FaceFaceIter | FaceFaceIter
| Circulator.
typedef Kernel::ConstVertexVertexIter | ConstVertexVertexIter
| Circulator.
typedef Kernel::ConstVertexOHalfedgeIter | ConstVertexOHalfedgeIter
| Circulator.
typedef Kernel::ConstVertexIHalfedgeIter | ConstVertexIHalfedgeIter
| Circulator.
typedef Kernel::ConstVertexEdgeIter | ConstVertexEdgeIter
| Circulator.
typedef Kernel::ConstVertexFaceIter | ConstVertexFaceIter
| Circulator.
typedef Kernel::ConstFaceVertexIter | ConstFaceVertexIter
| Circulator.
typedef Kernel::ConstFaceHalfedgeIter | ConstFaceHalfedgeIter
| Circulator.
typedef Kernel::ConstFaceEdgeIter | ConstFaceEdgeIter
| Circulator.
typedef Kernel::ConstFaceFaceIter | ConstFaceFaceIter
| Circulator.
enum | { IsPolyMesh = 1 }
| Determine whether this is a PolyMeshT or TriMeshT ( This function does not check the per face vertex count! It only checks if the datatype is PolyMeshT or TriMeshT )
enum | { IsTriMesh = 0 }
| Determine whether this is a PolyMeshT or TriMeshT ( This function does not check the per face vertex count! It only checks if the datatype is PolyMeshT or TriMeshT )
Public Member Functions inherited from OpenMesh::PolyMeshT< Kernel >
VertexHandle | new_vertex ()
| Uses default copy and assignment operator.
VertexHandle | new_vertex (const Point &_p)
VertexHandle | add_vertex (const Point &_p)
void | calc_edge_vector (EdgeHandle _eh, Normal &_edge_vec) const
| Calculates the edge vector as the vector defined by the halfedge with id #0 (see below)
void | calc_edge_vector (HalfedgeHandle _heh, Normal &_edge_vec) const
| Calculates the edge vector as the difference of the the points defined by to_vertex_handle() and from_vertex_handle()
Scalar | calc_edge_length (EdgeHandle _eh) const
Scalar | calc_edge_length (HalfedgeHandle _heh) const
| Calculates the length of the edge _heh.
Scalar | calc_edge_sqr_length (EdgeHandle _eh) const
Scalar | calc_edge_sqr_length (HalfedgeHandle _heh) const
void | calc_sector_vectors (HalfedgeHandle _in_heh, Normal &_vec0, Normal &_vec1) const
| defines a consistent representation of a sector geometry: the halfedge _in_heh defines the sector orientation the vertex pointed by _in_heh defines the sector center _vec0 and _vec1 are resp.
Scalar | calc_sector_angle (HalfedgeHandle _in_heh) const
| calculates the sector angle.
void | calc_sector_normal (HalfedgeHandle _in_heh, Normal &_sector_normal) const
| calculates the normal (non-normalized) of the face sector defined by the angle <(_in_heh,next_halfedge(_in_heh))
Scalar | calc_sector_area (HalfedgeHandle _in_heh) const
| calculates the area of the face sector defined by the angle <(_in_heh,next_halfedge(_in_heh)) NOTE: special cases (e.g.
Scalar | calc_dihedral_angle_fast (HalfedgeHandle _heh) const
| calculates the dihedral angle on the halfedge _heh
Scalar | calc_dihedral_angle_fast (EdgeHandle _eh) const
| calculates the dihedral angle on the edge _eh
Scalar | calc_dihedral_angle (HalfedgeHandle _heh) const
Scalar | calc_dihedral_angle (EdgeHandle _eh) const
unsigned int | find_feature_edges (Scalar _angle_tresh=OpenMesh::deg_to_rad(44.0))
| tags an edge as a feature if its dihedral angle is larger than _angle_tresh returns the number of the found feature edges, requires edge_status property
void | split (FaceHandle _fh, const Point &_p)
| Face split (= 1-to-n split)
void | split (FaceHandle _fh, VertexHandle _vh)
void | split (EdgeHandle _eh, const Point &_p)
void | split (EdgeHandle _eh, VertexHandle _vh)
void | update_normals ()
| Compute normals for all primitives.
void | update_normal (FaceHandle _fh)
| Update normal for face _fh.
void | update_face_normals ()
| Update normal vectors for all faces.
virtual Normal | calc_face_normal (FaceHandle _fh) const
| Calculate normal vector for face _fh.
Normal | calc_face_normal (const Point &_p0, const Point &_p1, const Point &_p2) const
| Calculate normal vector for face (_p0, _p1, _p2).
void | calc_face_centroid (FaceHandle _fh, Point &_pt) const
| calculates the average of the vertices defining _fh
void | update_normal (HalfedgeHandle _heh, const double _feature_angle=0.8)
| Update normal for halfedge _heh.
void | update_halfedge_normals (const double _feature_angle=0.8)
| Update normal vectors for all halfedges.
virtual Normal | calc_halfedge_normal (HalfedgeHandle _heh, const double _feature_angle=0.8) const
| Calculate halfedge normal for one specific halfedge.
bool | is_estimated_feature_edge (HalfedgeHandle _heh, const double _feature_angle) const
| identifies feature edges w.r.t.
void | update_normal (VertexHandle _vh)
| Update normal for vertex _vh.
void | update_vertex_normals ()
| Update normal vectors for all vertices.
Normal | calc_vertex_normal (VertexHandle _vh) const
| Calculate vertex normal for one specific vertex.
void | calc_vertex_normal_fast (VertexHandle _vh, Normal &_n) const
| Different methods for calculation of the normal at _vh:
void | calc_vertex_normal_correct (VertexHandle _vh, Normal &_n) const
| Compute normals for all primitives.
void | calc_vertex_normal_loop (VertexHandle _vh, Normal &_n) const
| Compute normals for all primitives.
Static Public Member Functions inherited from OpenMesh::PolyMeshT< Kernel >
static bool | is_polymesh ()
| Determine whether this is a PolyMeshT or TriMeshT ( This function does not check the per face vertex count! It only checks if the datatype is PolyMeshT or TriMeshT )
static bool | is_trimesh ()
| Determine whether this is a PolyMeshT or TriMeshT ( This function does not check the per face vertex count! It only checks if the datatype is PolyMeshT or TriMeshT )

## Detailed Description

### template<class Traits = DefaultTraits>
class OpenMesh::PolyMesh_ArrayKernelT< Traits >

Polygonal mesh based on the ArrayKernel.

See Also
  OpenMesh::PolyMeshT
  OpenMesh::ArrayKernel

The documentation for this class was generated from the following file:

- OpenMesh/Core/Mesh/PolyMesh_ArrayKernelT.hh